#!/usr/bin/env ruby
require "timeout"

$problem = "component"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
10.times { args << 10 ** 2 }
10.times { args << 10 ** 3 }


`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n|
    n = 1 + max_n + rand(max_n)
    input = [n]
    weight = []
    n.times { weight << 1 + rand(10 ** 5) }
    input << weight.join(" ")
    edges = []
    1.upto(n - 1) do |i|
        if rand(2) == 0
            edges << [i - 1 >> 1, i]
        else
            edges << [rand(i), i]
        end
    end
    label = (1..n).to_a.shuffle
    edges.shuffle.each do |a, b|
        input << "#{label[a]} #{label[b]}"
    end
    input
end
