#!/usr/bin/env ruby
require "timeout"

$problem = "cut"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
15.times { args << 10 ** 3 }
5.times { args << 10 ** 5 }


`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n|
    n = 1 + rand(max_n >> 1) + (max_n >> 1)
    n -= 1 if n % 2 == 1
    n += 2 if n == 0
    input = [n]
    edges = []
    1.upto(n - 1) { |i| edges << [rand(i), i] }
    label = (1..n).to_a.shuffle
    edges.shuffle.each do |a, b|
        input << "#{label[a]} #{label[b]}"
    end
    input
end
