#include <cassert>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int N = 100;
const int MOD = 1000000000 + 7;

int n, a[N][N];

int inverse(int a) {
    return a == 1 ? 1 : (long long)(MOD - MOD / a) * inverse(MOD % a) % MOD;
}

int main() {
    assert(scanf("%d", &n) == 1);
    assert(1 <= n && n <= N);
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < n; ++ j) {
            assert(scanf("%d", &a[i][j]) == 1);
        }
    }
    for (int i = 0; i < n; ++ i) {
        assert(a[i][i] == 0);
        for (int j = 0; j < n; ++ j) {
            assert(a[i][j] == a[j][i]);
            assert(a[i][j] == 0 || a[i][j] == 1);
        }
    }
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < n; ++ j) {
            if (a[i][j]) {
                a[i][j] = rand() % MOD;
                a[j][i] = MOD - a[i][j];
            }
        }
    }
    int rank = 0;
    for (int i = 0; i < n; ++ i) {
        int pivot = rank;
        while (pivot < n && !a[pivot][i]) {
            pivot ++;
        }
        if (pivot < n) {
            for (int j = 0; j < n; ++ j) {
                swap(a[rank][j], a[pivot][j]);
            }
            {
                int times = inverse(a[rank][i]);
                for (int j = 0; j < n; ++ j) {
                    a[rank][j] = (long long)a[rank][j] * times % MOD;
                }
                for (int k = 0; k < n; ++ k) {
                    if (k != rank && a[k][i]) {
                        int times = a[k][i];
                        for (int j = 0; j < n; ++ j) {
                            (a[k][j] += MOD - (long long)a[rank][j] * times % MOD) %= MOD;
                        }
                    }
                }
            }
            rank ++;
        }
    }
    assert(!(rank & 1));
    printf("%d\n", rank >> 1);
    return 0;
}
