#!/usr/bin/env ruby
require "timeout"

$problem = "multiplication"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
5.times { args << 10 ** 3 }
5.times { args << 10 ** 5 }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n, max_k|
    n = 1 + rand(max_n >> 1) + (max_n >> 1)
    input = [n]
    input << (1..n).map { rand(10 ** 9) }.join(" ")
    input << (1..n).map { rand(10 ** 9) }.join(" ")
    input
end
