#!/usr/bin/env ruby
require "timeout"

$problem = "path"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
5.times { args << 10 ** 3 }
5.times { args << 10 ** 5 }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n|
    n, q = 1 + rand(max_n >> 1) + (max_n >> 1), \
           1 + rand(max_n >> 1) + (max_n >> 1)
    input = ["#{n} #{q}"]
    edges = []
    0.upto(n - 2) do |i|
        edges << [i, [i + 1 + rand(10), n - 1].min]
    end
    label = (1..n).to_a.shuffle
    edges.shuffle.each do |a, b|
        input << "#{label[a]} #{label[b]} #{[1, rand(3)].max} "
    end
    input << (1..q).map { rand(2 * n)  - n / 10 }.join(" ")
    input
end
