#include <cassert>
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

const int N = 100000;
const int INF = 1000000000;

int a, b, minimum[N + 1];
vector <int> divisors[N + 1];

#define foreach(i, v) for (__typeof((v).begin()) i = (v).begin(); i != (v).end(); ++ i) 

int main() {
    for (int i = 1; i <= N; ++ i) {
        for (int j = i; j <= N; j += i) {
            divisors[j].push_back(i);
        }
    }
    assert(scanf("%d%d", &a, &b) == 2);
    assert(1 <= a && a <= N && 1 <= b && b <= N);
    for (int i = 1; i <= N; ++ i) {
        minimum[i] = INF;
    }
    minimum[b] = 0;
    for (int i = b - 1; i >= a; -- i) {
        minimum[i] = INF;
        foreach (iter, divisors[i]) {
            int d = *iter;
            if (i + d <= N) {
                minimum[i] = min(minimum[i], minimum[i + d] + 1);
            }
        }
    }
    printf("%d\n", minimum[a] == INF ? -1 : minimum[a]);
    return 0;
}
