#!/usr/bin/env ruby
require "timeout"

$problem = "triangle"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
10.times do |i|
    args << 10 ** i
end

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |n|
    ["#{1 + rand(n)} #{1 + rand(n)}"]
end
