#!/usr/bin/env ruby
require "timeout"

$problem = "xor"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
10.times { args << [10 ** 3, 10] }
20.times { args << [10 ** 3, 20] }
5.times { args << [10 ** 5, 30] }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n, max_k|
    n = 1 + rand(max_n >> 1) + (max_n >> 1)
    n -= 1 if n % 2 == 0
    input = [n]
    a = []
    n.times { a << rand(2 ** max_k) }
    x = rand(2 ** max_k)
    input << a.join(" ")
    a.map! { |a| a ^ x }
    if rand(4) == 0
        rand(n).times { a[rand(n)] = rand(2 ** max_k) }
    end
    input << a.join(" ")
    input
end
